// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `matt.ice'

#include <matt.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __matt__messaging__EventListener__onEvent_name = "onEvent";

static const ::std::string __matt__messaging__Mailbox__empty_name = "empty";

static const ::std::string __matt__messaging__Mailbox__active_name = "active";

static const ::std::string __matt__messaging__Mailbox__read_name = "read";

static const ::std::string __matt__messaging__Mailbox__write_name = "write";

static const ::std::string __matt__messaging__Mailbox__addListener_name = "addListener";

static const ::std::string __matt__messaging__Mailbox__removeListener_name = "removeListener";

static const ::std::string __matt__roles__Participant__setMailbox_name = "setMailbox";

static const ::std::string __matt__roles__Mediator__registerParticipant_name = "registerParticipant";

void
IceInternal::incRef(::matt::messaging::EventListener* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::matt::messaging::EventListener* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::matt::messaging::EventListener* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::matt::messaging::EventListener* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::matt::messaging::Mailbox* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::matt::messaging::Mailbox* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::matt::messaging::Mailbox* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::matt::messaging::Mailbox* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::matt::roles::Participant* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::matt::roles::Participant* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::matt::roles::Participant* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::matt::roles::Participant* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::matt::roles::Mediator* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::matt::roles::Mediator* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::matt::roles::Mediator* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::matt::roles::Mediator* p)
{
    p->__decRef();
}

void
matt::messaging::__write(::IceInternal::BasicStream* __os, const ::matt::messaging::EventListenerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
matt::messaging::__read(::IceInternal::BasicStream* __is, ::matt::messaging::EventListenerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::matt::messaging::EventListener;
        v->__copyFrom(proxy);
    }
}

void
matt::messaging::__write(::IceInternal::BasicStream* __os, const ::matt::messaging::EventListenerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
matt::messaging::__write(::IceInternal::BasicStream* __os, const ::matt::messaging::MailboxPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
matt::messaging::__read(::IceInternal::BasicStream* __is, ::matt::messaging::MailboxPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::matt::messaging::Mailbox;
        v->__copyFrom(proxy);
    }
}

void
matt::messaging::__write(::IceInternal::BasicStream* __os, const ::matt::messaging::MailboxPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
matt::roles::__write(::IceInternal::BasicStream* __os, const ::matt::roles::ParticipantPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
matt::roles::__read(::IceInternal::BasicStream* __is, ::matt::roles::ParticipantPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::matt::roles::Participant;
        v->__copyFrom(proxy);
    }
}

void
matt::roles::__write(::IceInternal::BasicStream* __os, const ::matt::roles::ParticipantPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
matt::roles::__write(::IceInternal::BasicStream* __os, const ::matt::roles::MediatorPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
matt::roles::__read(::IceInternal::BasicStream* __is, ::matt::roles::MediatorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::matt::roles::Mediator;
        v->__copyFrom(proxy);
    }
}

void
matt::roles::__write(::IceInternal::BasicStream* __os, const ::matt::roles::MediatorPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

matt::MattException::MattException(const ::std::string& __ice_description) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    description(__ice_description)
{
}

matt::MattException::~MattException() throw()
{
}

static const char* __matt__MattException_name = "matt::MattException";

::std::string
matt::MattException::ice_name() const
{
    return __matt__MattException_name;
}

::Ice::Exception*
matt::MattException::ice_clone() const
{
    return new MattException(*this);
}

void
matt::MattException::ice_throw() const
{
    throw *this;
}

void
matt::MattException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::matt::MattException"), false);
    __os->startWriteSlice();
    __os->write(description);
    __os->endWriteSlice();
}

void
matt::MattException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(description);
    __is->endReadSlice();
}

void
matt::MattException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattException was not generated with stream support";
    throw ex;
}

void
matt::MattException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattException was not generated with stream support";
    throw ex;
}

struct __F__matt__MattException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::matt::MattException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__matt__MattException__Ptr = new __F__matt__MattException;

const ::IceInternal::UserExceptionFactoryPtr&
matt::MattException::ice_factory()
{
    return __F__matt__MattException__Ptr;
}

class __F__matt__MattException__Init
{
public:

    __F__matt__MattException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::matt::MattException", ::matt::MattException::ice_factory());
    }

    ~__F__matt__MattException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::matt::MattException");
    }
};

static __F__matt__MattException__Init __F__matt__MattException__i;

#ifdef __APPLE__
extern "C" { void __F__matt__MattException__initializer() {} }
#endif

matt::MattNotActiveException::MattNotActiveException(const ::std::string& __ice_description) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException(__ice_description)
#else
    ::matt::MattException(__ice_description)
#endif
{
}

matt::MattNotActiveException::~MattNotActiveException() throw()
{
}

static const char* __matt__MattNotActiveException_name = "matt::MattNotActiveException";

::std::string
matt::MattNotActiveException::ice_name() const
{
    return __matt__MattNotActiveException_name;
}

::Ice::Exception*
matt::MattNotActiveException::ice_clone() const
{
    return new MattNotActiveException(*this);
}

void
matt::MattNotActiveException::ice_throw() const
{
    throw *this;
}

void
matt::MattNotActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::matt::MattNotActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException::__write(__os);
#else
    ::matt::MattException::__write(__os);
#endif
}

void
matt::MattNotActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException::__read(__is, true);
#else
    ::matt::MattException::__read(__is, true);
#endif
}

void
matt::MattNotActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattNotActiveException was not generated with stream support";
    throw ex;
}

void
matt::MattNotActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattNotActiveException was not generated with stream support";
    throw ex;
}

struct __F__matt__MattNotActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::matt::MattNotActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__matt__MattNotActiveException__Ptr = new __F__matt__MattNotActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
matt::MattNotActiveException::ice_factory()
{
    return __F__matt__MattNotActiveException__Ptr;
}

class __F__matt__MattNotActiveException__Init
{
public:

    __F__matt__MattNotActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::matt::MattNotActiveException", ::matt::MattNotActiveException::ice_factory());
    }

    ~__F__matt__MattNotActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::matt::MattNotActiveException");
    }
};

static __F__matt__MattNotActiveException__Init __F__matt__MattNotActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__matt__MattNotActiveException__initializer() {} }
#endif

matt::MattNoMessageException::MattNoMessageException(const ::std::string& __ice_description) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException(__ice_description)
#else
    ::matt::MattException(__ice_description)
#endif
{
}

matt::MattNoMessageException::~MattNoMessageException() throw()
{
}

static const char* __matt__MattNoMessageException_name = "matt::MattNoMessageException";

::std::string
matt::MattNoMessageException::ice_name() const
{
    return __matt__MattNoMessageException_name;
}

::Ice::Exception*
matt::MattNoMessageException::ice_clone() const
{
    return new MattNoMessageException(*this);
}

void
matt::MattNoMessageException::ice_throw() const
{
    throw *this;
}

void
matt::MattNoMessageException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::matt::MattNoMessageException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException::__write(__os);
#else
    ::matt::MattException::__write(__os);
#endif
}

void
matt::MattNoMessageException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException::__read(__is, true);
#else
    ::matt::MattException::__read(__is, true);
#endif
}

void
matt::MattNoMessageException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattNoMessageException was not generated with stream support";
    throw ex;
}

void
matt::MattNoMessageException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattNoMessageException was not generated with stream support";
    throw ex;
}

struct __F__matt__MattNoMessageException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::matt::MattNoMessageException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__matt__MattNoMessageException__Ptr = new __F__matt__MattNoMessageException;

const ::IceInternal::UserExceptionFactoryPtr&
matt::MattNoMessageException::ice_factory()
{
    return __F__matt__MattNoMessageException__Ptr;
}

class __F__matt__MattNoMessageException__Init
{
public:

    __F__matt__MattNoMessageException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::matt::MattNoMessageException", ::matt::MattNoMessageException::ice_factory());
    }

    ~__F__matt__MattNoMessageException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::matt::MattNoMessageException");
    }
};

static __F__matt__MattNoMessageException__Init __F__matt__MattNoMessageException__i;

#ifdef __APPLE__
extern "C" { void __F__matt__MattNoMessageException__initializer() {} }
#endif

matt::MattListenException::MattListenException(const ::std::string& __ice_description) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException(__ice_description)
#else
    ::matt::MattException(__ice_description)
#endif
{
}

matt::MattListenException::~MattListenException() throw()
{
}

static const char* __matt__MattListenException_name = "matt::MattListenException";

::std::string
matt::MattListenException::ice_name() const
{
    return __matt__MattListenException_name;
}

::Ice::Exception*
matt::MattListenException::ice_clone() const
{
    return new MattListenException(*this);
}

void
matt::MattListenException::ice_throw() const
{
    throw *this;
}

void
matt::MattListenException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::matt::MattListenException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException::__write(__os);
#else
    ::matt::MattException::__write(__os);
#endif
}

void
matt::MattListenException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattException::__read(__is, true);
#else
    ::matt::MattException::__read(__is, true);
#endif
}

void
matt::MattListenException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattListenException was not generated with stream support";
    throw ex;
}

void
matt::MattListenException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattListenException was not generated with stream support";
    throw ex;
}

struct __F__matt__MattListenException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::matt::MattListenException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__matt__MattListenException__Ptr = new __F__matt__MattListenException;

const ::IceInternal::UserExceptionFactoryPtr&
matt::MattListenException::ice_factory()
{
    return __F__matt__MattListenException__Ptr;
}

class __F__matt__MattListenException__Init
{
public:

    __F__matt__MattListenException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::matt::MattListenException", ::matt::MattListenException::ice_factory());
    }

    ~__F__matt__MattListenException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::matt::MattListenException");
    }
};

static __F__matt__MattListenException__Init __F__matt__MattListenException__i;

#ifdef __APPLE__
extern "C" { void __F__matt__MattListenException__initializer() {} }
#endif

matt::MattAlreadyListeningException::MattAlreadyListeningException(const ::std::string& __ice_description) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattListenException(__ice_description)
#else
    ::matt::MattListenException(__ice_description)
#endif
{
}

matt::MattAlreadyListeningException::~MattAlreadyListeningException() throw()
{
}

static const char* __matt__MattAlreadyListeningException_name = "matt::MattAlreadyListeningException";

::std::string
matt::MattAlreadyListeningException::ice_name() const
{
    return __matt__MattAlreadyListeningException_name;
}

::Ice::Exception*
matt::MattAlreadyListeningException::ice_clone() const
{
    return new MattAlreadyListeningException(*this);
}

void
matt::MattAlreadyListeningException::ice_throw() const
{
    throw *this;
}

void
matt::MattAlreadyListeningException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::matt::MattAlreadyListeningException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattListenException::__write(__os);
#else
    ::matt::MattListenException::__write(__os);
#endif
}

void
matt::MattAlreadyListeningException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattListenException::__read(__is, true);
#else
    ::matt::MattListenException::__read(__is, true);
#endif
}

void
matt::MattAlreadyListeningException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattAlreadyListeningException was not generated with stream support";
    throw ex;
}

void
matt::MattAlreadyListeningException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattAlreadyListeningException was not generated with stream support";
    throw ex;
}

struct __F__matt__MattAlreadyListeningException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::matt::MattAlreadyListeningException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__matt__MattAlreadyListeningException__Ptr = new __F__matt__MattAlreadyListeningException;

const ::IceInternal::UserExceptionFactoryPtr&
matt::MattAlreadyListeningException::ice_factory()
{
    return __F__matt__MattAlreadyListeningException__Ptr;
}

class __F__matt__MattAlreadyListeningException__Init
{
public:

    __F__matt__MattAlreadyListeningException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::matt::MattAlreadyListeningException", ::matt::MattAlreadyListeningException::ice_factory());
    }

    ~__F__matt__MattAlreadyListeningException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::matt::MattAlreadyListeningException");
    }
};

static __F__matt__MattAlreadyListeningException__Init __F__matt__MattAlreadyListeningException__i;

#ifdef __APPLE__
extern "C" { void __F__matt__MattAlreadyListeningException__initializer() {} }
#endif

matt::MattNotListeningException::MattNotListeningException(const ::std::string& __ice_description) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattListenException(__ice_description)
#else
    ::matt::MattListenException(__ice_description)
#endif
{
}

matt::MattNotListeningException::~MattNotListeningException() throw()
{
}

static const char* __matt__MattNotListeningException_name = "matt::MattNotListeningException";

::std::string
matt::MattNotListeningException::ice_name() const
{
    return __matt__MattNotListeningException_name;
}

::Ice::Exception*
matt::MattNotListeningException::ice_clone() const
{
    return new MattNotListeningException(*this);
}

void
matt::MattNotListeningException::ice_throw() const
{
    throw *this;
}

void
matt::MattNotListeningException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::matt::MattNotListeningException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattListenException::__write(__os);
#else
    ::matt::MattListenException::__write(__os);
#endif
}

void
matt::MattNotListeningException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    MattListenException::__read(__is, true);
#else
    ::matt::MattListenException::__read(__is, true);
#endif
}

void
matt::MattNotListeningException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattNotListeningException was not generated with stream support";
    throw ex;
}

void
matt::MattNotListeningException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception matt::MattNotListeningException was not generated with stream support";
    throw ex;
}

struct __F__matt__MattNotListeningException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::matt::MattNotListeningException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__matt__MattNotListeningException__Ptr = new __F__matt__MattNotListeningException;

const ::IceInternal::UserExceptionFactoryPtr&
matt::MattNotListeningException::ice_factory()
{
    return __F__matt__MattNotListeningException__Ptr;
}

class __F__matt__MattNotListeningException__Init
{
public:

    __F__matt__MattNotListeningException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::matt::MattNotListeningException", ::matt::MattNotListeningException::ice_factory());
    }

    ~__F__matt__MattNotListeningException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::matt::MattNotListeningException");
    }
};

static __F__matt__MattNotListeningException__Init __F__matt__MattNotListeningException__i;

#ifdef __APPLE__
extern "C" { void __F__matt__MattNotListeningException__initializer() {} }
#endif

void
matt::messaging::__write(::IceInternal::BasicStream* __os, ::matt::messaging::EventType v)
{
    __os->write(static_cast< ::Ice::Byte>(v));
}

void
matt::messaging::__read(::IceInternal::BasicStream* __is, ::matt::messaging::EventType& v)
{
    ::Ice::Byte val;
    __is->read(val);
    v = static_cast< ::matt::messaging::EventType>(val);
}

void
matt::messaging::__addObject(const EventListenerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
matt::messaging::__usesClasses(const EventListenerPtr& p)
{
    return p->__usesClasses();
}

void
matt::messaging::__decRefUnsafe(const EventListenerPtr& p)
{
    p->__decRefUnsafe();
}

void
matt::messaging::__clearHandleUnsafe(EventListenerPtr& p)
{
    p.__clearHandleUnsafe();
}

void
matt::messaging::__addObject(const MailboxPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
matt::messaging::__usesClasses(const MailboxPtr& p)
{
    return p->__usesClasses();
}

void
matt::messaging::__decRefUnsafe(const MailboxPtr& p)
{
    p->__decRefUnsafe();
}

void
matt::messaging::__clearHandleUnsafe(MailboxPtr& p)
{
    p.__clearHandleUnsafe();
}

void
matt::roles::__addObject(const ParticipantPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
matt::roles::__usesClasses(const ParticipantPtr& p)
{
    return p->__usesClasses();
}

void
matt::roles::__decRefUnsafe(const ParticipantPtr& p)
{
    p->__decRefUnsafe();
}

void
matt::roles::__clearHandleUnsafe(ParticipantPtr& p)
{
    p.__clearHandleUnsafe();
}

void
matt::roles::__addObject(const MediatorPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
matt::roles::__usesClasses(const MediatorPtr& p)
{
    return p->__usesClasses();
}

void
matt::roles::__decRefUnsafe(const MediatorPtr& p)
{
    p->__decRefUnsafe();
}

void
matt::roles::__clearHandleUnsafe(MediatorPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceProxy::matt::messaging::EventListener::onEvent(::matt::messaging::EventType event, const ::std::string& message, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::EventListener* __del = dynamic_cast< ::IceDelegate::matt::messaging::EventListener*>(__delBase.get());
            __del->onEvent(event, message, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::matt::messaging::EventListener::ice_staticId()
{
    return ::matt::messaging::EventListener::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::matt::messaging::EventListener::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::matt::messaging::EventListener);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::matt::messaging::EventListener::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::matt::messaging::EventListener);
}

bool
IceProxy::matt::messaging::operator==(const ::IceProxy::matt::messaging::EventListener& l, const ::IceProxy::matt::messaging::EventListener& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::messaging::operator!=(const ::IceProxy::matt::messaging::EventListener& l, const ::IceProxy::matt::messaging::EventListener& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::messaging::operator<(const ::IceProxy::matt::messaging::EventListener& l, const ::IceProxy::matt::messaging::EventListener& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::messaging::operator<=(const ::IceProxy::matt::messaging::EventListener& l, const ::IceProxy::matt::messaging::EventListener& r)
{
    return l < r || l == r;
}

bool
IceProxy::matt::messaging::operator>(const ::IceProxy::matt::messaging::EventListener& l, const ::IceProxy::matt::messaging::EventListener& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::matt::messaging::operator>=(const ::IceProxy::matt::messaging::EventListener& l, const ::IceProxy::matt::messaging::EventListener& r)
{
    return !(l < r);
}

bool
IceProxy::matt::messaging::Mailbox::empty(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__matt__messaging__Mailbox__empty_name);
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::Mailbox* __del = dynamic_cast< ::IceDelegate::matt::messaging::Mailbox*>(__delBase.get());
            return __del->empty(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

bool
IceProxy::matt::messaging::Mailbox::active(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__matt__messaging__Mailbox__active_name);
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::Mailbox* __del = dynamic_cast< ::IceDelegate::matt::messaging::Mailbox*>(__delBase.get());
            return __del->active(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::std::string
IceProxy::matt::messaging::Mailbox::read(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__matt__messaging__Mailbox__read_name);
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::Mailbox* __del = dynamic_cast< ::IceDelegate::matt::messaging::Mailbox*>(__delBase.get());
            return __del->read(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::matt::messaging::Mailbox::write(const ::std::string& message, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__matt__messaging__Mailbox__write_name);
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::Mailbox* __del = dynamic_cast< ::IceDelegate::matt::messaging::Mailbox*>(__delBase.get());
            __del->write(message, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::matt::messaging::Mailbox::addListener(const ::matt::messaging::EventListenerPrx& listener, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__matt__messaging__Mailbox__addListener_name);
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::Mailbox* __del = dynamic_cast< ::IceDelegate::matt::messaging::Mailbox*>(__delBase.get());
            __del->addListener(listener, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::matt::messaging::Mailbox::removeListener(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__matt__messaging__Mailbox__removeListener_name);
            __delBase = __getDelegate();
            ::IceDelegate::matt::messaging::Mailbox* __del = dynamic_cast< ::IceDelegate::matt::messaging::Mailbox*>(__delBase.get());
            __del->removeListener(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::matt::messaging::Mailbox::ice_staticId()
{
    return ::matt::messaging::Mailbox::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::matt::messaging::Mailbox::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::matt::messaging::Mailbox);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::matt::messaging::Mailbox::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::matt::messaging::Mailbox);
}

bool
IceProxy::matt::messaging::operator==(const ::IceProxy::matt::messaging::Mailbox& l, const ::IceProxy::matt::messaging::Mailbox& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::messaging::operator!=(const ::IceProxy::matt::messaging::Mailbox& l, const ::IceProxy::matt::messaging::Mailbox& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::messaging::operator<(const ::IceProxy::matt::messaging::Mailbox& l, const ::IceProxy::matt::messaging::Mailbox& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::messaging::operator<=(const ::IceProxy::matt::messaging::Mailbox& l, const ::IceProxy::matt::messaging::Mailbox& r)
{
    return l < r || l == r;
}

bool
IceProxy::matt::messaging::operator>(const ::IceProxy::matt::messaging::Mailbox& l, const ::IceProxy::matt::messaging::Mailbox& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::matt::messaging::operator>=(const ::IceProxy::matt::messaging::Mailbox& l, const ::IceProxy::matt::messaging::Mailbox& r)
{
    return !(l < r);
}

void
IceProxy::matt::roles::Participant::setMailbox(const ::matt::messaging::MailboxPrx& mb, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::matt::roles::Participant* __del = dynamic_cast< ::IceDelegate::matt::roles::Participant*>(__delBase.get());
            __del->setMailbox(mb, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::matt::roles::Participant::ice_staticId()
{
    return ::matt::roles::Participant::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::matt::roles::Participant::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::matt::roles::Participant);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::matt::roles::Participant::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::matt::roles::Participant);
}

bool
IceProxy::matt::roles::operator==(const ::IceProxy::matt::roles::Participant& l, const ::IceProxy::matt::roles::Participant& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::roles::operator!=(const ::IceProxy::matt::roles::Participant& l, const ::IceProxy::matt::roles::Participant& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::roles::operator<(const ::IceProxy::matt::roles::Participant& l, const ::IceProxy::matt::roles::Participant& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::roles::operator<=(const ::IceProxy::matt::roles::Participant& l, const ::IceProxy::matt::roles::Participant& r)
{
    return l < r || l == r;
}

bool
IceProxy::matt::roles::operator>(const ::IceProxy::matt::roles::Participant& l, const ::IceProxy::matt::roles::Participant& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::matt::roles::operator>=(const ::IceProxy::matt::roles::Participant& l, const ::IceProxy::matt::roles::Participant& r)
{
    return !(l < r);
}

void
IceProxy::matt::roles::Mediator::registerParticipant(const ::matt::roles::ParticipantPrx& p, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::matt::roles::Mediator* __del = dynamic_cast< ::IceDelegate::matt::roles::Mediator*>(__delBase.get());
            __del->registerParticipant(p, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::matt::roles::Mediator::ice_staticId()
{
    return ::matt::roles::Mediator::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::matt::roles::Mediator::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::matt::roles::Mediator);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::matt::roles::Mediator::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::matt::roles::Mediator);
}

bool
IceProxy::matt::roles::operator==(const ::IceProxy::matt::roles::Mediator& l, const ::IceProxy::matt::roles::Mediator& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::roles::operator!=(const ::IceProxy::matt::roles::Mediator& l, const ::IceProxy::matt::roles::Mediator& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::roles::operator<(const ::IceProxy::matt::roles::Mediator& l, const ::IceProxy::matt::roles::Mediator& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::matt::roles::operator<=(const ::IceProxy::matt::roles::Mediator& l, const ::IceProxy::matt::roles::Mediator& r)
{
    return l < r || l == r;
}

bool
IceProxy::matt::roles::operator>(const ::IceProxy::matt::roles::Mediator& l, const ::IceProxy::matt::roles::Mediator& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::matt::roles::operator>=(const ::IceProxy::matt::roles::Mediator& l, const ::IceProxy::matt::roles::Mediator& r)
{
    return !(l < r);
}

void
IceDelegateM::matt::messaging::EventListener::onEvent(::matt::messaging::EventType event, const ::std::string& message, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__EventListener__onEvent_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::matt::messaging::__write(__os, event);
        __os->write(message);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::matt::messaging::Mailbox::empty(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__Mailbox__empty_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::matt::messaging::Mailbox::active(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__Mailbox__active_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateM::matt::messaging::Mailbox::read(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__Mailbox__read_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::matt::MattNoMessageException&)
            {
                throw;
            }
            catch(const ::matt::MattNotActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::std::string __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::matt::messaging::Mailbox::write(const ::std::string& message, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__Mailbox__write_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(message);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::matt::MattNotActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::matt::messaging::Mailbox::addListener(const ::matt::messaging::EventListenerPrx& listener, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__Mailbox__addListener_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::matt::messaging::__write(__os, listener);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::matt::MattAlreadyListeningException&)
            {
                throw;
            }
            catch(const ::matt::MattListenException&)
            {
                throw;
            }
            catch(const ::matt::MattNotActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::matt::messaging::Mailbox::removeListener(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__messaging__Mailbox__removeListener_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::matt::MattNotListeningException&)
            {
                throw;
            }
            catch(const ::matt::MattListenException&)
            {
                throw;
            }
            catch(const ::matt::MattNotActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::matt::roles::Participant::setMailbox(const ::matt::messaging::MailboxPrx& mb, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__roles__Participant__setMailbox_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::matt::messaging::__write(__os, mb);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::matt::roles::Mediator::registerParticipant(const ::matt::roles::ParticipantPrx& p, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __matt__roles__Mediator__registerParticipant_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::matt::roles::__write(__os, p);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::matt::messaging::EventListener::onEvent(::matt::messaging::EventType event, const ::std::string& message, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__EventListener__onEvent_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::matt::messaging::EventListener* __servant = dynamic_cast< ::matt::messaging::EventListener*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->onEvent(event, message, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

bool
IceDelegateD::matt::messaging::Mailbox::empty(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__Mailbox__empty_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::matt::messaging::Mailbox* __servant = dynamic_cast< ::matt::messaging::Mailbox*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->empty(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

bool
IceDelegateD::matt::messaging::Mailbox::active(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__Mailbox__active_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::matt::messaging::Mailbox* __servant = dynamic_cast< ::matt::messaging::Mailbox*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->active(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::std::string
IceDelegateD::matt::messaging::Mailbox::read(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__Mailbox__read_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::std::string __ret;
        try
        {
            ::matt::messaging::Mailbox* __servant = dynamic_cast< ::matt::messaging::Mailbox*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->read(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::matt::messaging::Mailbox::write(const ::std::string& message, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__Mailbox__write_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::matt::messaging::Mailbox* __servant = dynamic_cast< ::matt::messaging::Mailbox*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->write(message, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::matt::messaging::Mailbox::addListener(const ::matt::messaging::EventListenerPrx& listener, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__Mailbox__addListener_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::matt::messaging::Mailbox* __servant = dynamic_cast< ::matt::messaging::Mailbox*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->addListener(listener, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::matt::messaging::Mailbox::removeListener(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__messaging__Mailbox__removeListener_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::matt::messaging::Mailbox* __servant = dynamic_cast< ::matt::messaging::Mailbox*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->removeListener(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::matt::roles::Participant::setMailbox(const ::matt::messaging::MailboxPrx& mb, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__roles__Participant__setMailbox_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::matt::roles::Participant* __servant = dynamic_cast< ::matt::roles::Participant*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setMailbox(mb, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::matt::roles::Mediator::registerParticipant(const ::matt::roles::ParticipantPrx& p, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __matt__roles__Mediator__registerParticipant_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::matt::roles::Mediator* __servant = dynamic_cast< ::matt::roles::Mediator*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registerParticipant(p, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPtr
matt::messaging::EventListener::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __matt__messaging__EventListener_ids[2] =
{
    "::Ice::Object",
    "::matt::messaging::EventListener"
};

bool
matt::messaging::EventListener::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__matt__messaging__EventListener_ids, __matt__messaging__EventListener_ids + 2, _s);
}

::std::vector< ::std::string>
matt::messaging::EventListener::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__matt__messaging__EventListener_ids[0], &__matt__messaging__EventListener_ids[2]);
}

const ::std::string&
matt::messaging::EventListener::ice_id(const ::Ice::Current&) const
{
    return __matt__messaging__EventListener_ids[1];
}

const ::std::string&
matt::messaging::EventListener::ice_staticId()
{
    return __matt__messaging__EventListener_ids[1];
}

::IceInternal::DispatchStatus
matt::messaging::EventListener::___onEvent(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::matt::messaging::EventType event;
    ::std::string message;
    ::matt::messaging::__read(__is, event);
    __is->read(message);
    onEvent(event, message, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __matt__messaging__EventListener_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "onEvent"
};

::IceInternal::DispatchStatus
matt::messaging::EventListener::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__matt__messaging__EventListener_all, __matt__messaging__EventListener_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __matt__messaging__EventListener_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___onEvent(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
matt::messaging::EventListener::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
matt::messaging::EventListener::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
matt::messaging::EventListener::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::messaging::EventListener was not generated with stream support";
    throw ex;
}

void
matt::messaging::EventListener::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::messaging::EventListener was not generated with stream support";
    throw ex;
}

void 
matt::messaging::__patch__EventListenerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::matt::messaging::EventListenerPtr* p = static_cast< ::matt::messaging::EventListenerPtr*>(__addr);
    assert(p);
    *p = ::matt::messaging::EventListenerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::matt::messaging::EventListener::ice_staticId();
        throw e;
    }
}

bool
matt::messaging::operator==(const ::matt::messaging::EventListener& l, const ::matt::messaging::EventListener& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
matt::messaging::operator!=(const ::matt::messaging::EventListener& l, const ::matt::messaging::EventListener& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
matt::messaging::operator<(const ::matt::messaging::EventListener& l, const ::matt::messaging::EventListener& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
matt::messaging::operator<=(const ::matt::messaging::EventListener& l, const ::matt::messaging::EventListener& r)
{
    return l < r || l == r;
}

bool
matt::messaging::operator>(const ::matt::messaging::EventListener& l, const ::matt::messaging::EventListener& r)
{
    return !(l < r) && !(l == r);
}

bool
matt::messaging::operator>=(const ::matt::messaging::EventListener& l, const ::matt::messaging::EventListener& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
matt::messaging::Mailbox::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __matt__messaging__Mailbox_ids[2] =
{
    "::Ice::Object",
    "::matt::messaging::Mailbox"
};

bool
matt::messaging::Mailbox::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__matt__messaging__Mailbox_ids, __matt__messaging__Mailbox_ids + 2, _s);
}

::std::vector< ::std::string>
matt::messaging::Mailbox::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__matt__messaging__Mailbox_ids[0], &__matt__messaging__Mailbox_ids[2]);
}

const ::std::string&
matt::messaging::Mailbox::ice_id(const ::Ice::Current&) const
{
    return __matt__messaging__Mailbox_ids[1];
}

const ::std::string&
matt::messaging::Mailbox::ice_staticId()
{
    return __matt__messaging__Mailbox_ids[1];
}

::IceInternal::DispatchStatus
matt::messaging::Mailbox::___empty(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = empty(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
matt::messaging::Mailbox::___active(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = active(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
matt::messaging::Mailbox::___read(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::std::string __ret = read(__current);
        __os->write(__ret);
    }
    catch(const ::matt::MattNoMessageException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::matt::MattNotActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
matt::messaging::Mailbox::___write(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string message;
    __is->read(message);
    try
    {
        write(message, __current);
    }
    catch(const ::matt::MattNotActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
matt::messaging::Mailbox::___addListener(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::matt::messaging::EventListenerPrx listener;
    ::matt::messaging::__read(__is, listener);
    try
    {
        addListener(listener, __current);
    }
    catch(const ::matt::MattAlreadyListeningException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::matt::MattListenException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::matt::MattNotActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
matt::messaging::Mailbox::___removeListener(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        removeListener(__current);
    }
    catch(const ::matt::MattNotListeningException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::matt::MattListenException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::matt::MattNotActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __matt__messaging__Mailbox_all[] =
{
    "active",
    "addListener",
    "empty",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "read",
    "removeListener",
    "write"
};

::IceInternal::DispatchStatus
matt::messaging::Mailbox::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__matt__messaging__Mailbox_all, __matt__messaging__Mailbox_all + 10, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __matt__messaging__Mailbox_all)
    {
        case 0:
        {
            return ___active(in, current);
        }
        case 1:
        {
            return ___addListener(in, current);
        }
        case 2:
        {
            return ___empty(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___read(in, current);
        }
        case 8:
        {
            return ___removeListener(in, current);
        }
        case 9:
        {
            return ___write(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
matt::messaging::Mailbox::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
matt::messaging::Mailbox::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
matt::messaging::Mailbox::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::messaging::Mailbox was not generated with stream support";
    throw ex;
}

void
matt::messaging::Mailbox::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::messaging::Mailbox was not generated with stream support";
    throw ex;
}

void 
matt::messaging::__patch__MailboxPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::matt::messaging::MailboxPtr* p = static_cast< ::matt::messaging::MailboxPtr*>(__addr);
    assert(p);
    *p = ::matt::messaging::MailboxPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::matt::messaging::Mailbox::ice_staticId();
        throw e;
    }
}

bool
matt::messaging::operator==(const ::matt::messaging::Mailbox& l, const ::matt::messaging::Mailbox& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
matt::messaging::operator!=(const ::matt::messaging::Mailbox& l, const ::matt::messaging::Mailbox& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
matt::messaging::operator<(const ::matt::messaging::Mailbox& l, const ::matt::messaging::Mailbox& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
matt::messaging::operator<=(const ::matt::messaging::Mailbox& l, const ::matt::messaging::Mailbox& r)
{
    return l < r || l == r;
}

bool
matt::messaging::operator>(const ::matt::messaging::Mailbox& l, const ::matt::messaging::Mailbox& r)
{
    return !(l < r) && !(l == r);
}

bool
matt::messaging::operator>=(const ::matt::messaging::Mailbox& l, const ::matt::messaging::Mailbox& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
matt::roles::Participant::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __matt__roles__Participant_ids[2] =
{
    "::Ice::Object",
    "::matt::roles::Participant"
};

bool
matt::roles::Participant::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__matt__roles__Participant_ids, __matt__roles__Participant_ids + 2, _s);
}

::std::vector< ::std::string>
matt::roles::Participant::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__matt__roles__Participant_ids[0], &__matt__roles__Participant_ids[2]);
}

const ::std::string&
matt::roles::Participant::ice_id(const ::Ice::Current&) const
{
    return __matt__roles__Participant_ids[1];
}

const ::std::string&
matt::roles::Participant::ice_staticId()
{
    return __matt__roles__Participant_ids[1];
}

::IceInternal::DispatchStatus
matt::roles::Participant::___setMailbox(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::matt::messaging::MailboxPrx mb;
    ::matt::messaging::__read(__is, mb);
    setMailbox(mb, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __matt__roles__Participant_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "setMailbox"
};

::IceInternal::DispatchStatus
matt::roles::Participant::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__matt__roles__Participant_all, __matt__roles__Participant_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __matt__roles__Participant_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___setMailbox(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
matt::roles::Participant::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
matt::roles::Participant::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
matt::roles::Participant::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::roles::Participant was not generated with stream support";
    throw ex;
}

void
matt::roles::Participant::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::roles::Participant was not generated with stream support";
    throw ex;
}

void 
matt::roles::__patch__ParticipantPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::matt::roles::ParticipantPtr* p = static_cast< ::matt::roles::ParticipantPtr*>(__addr);
    assert(p);
    *p = ::matt::roles::ParticipantPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::matt::roles::Participant::ice_staticId();
        throw e;
    }
}

bool
matt::roles::operator==(const ::matt::roles::Participant& l, const ::matt::roles::Participant& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
matt::roles::operator!=(const ::matt::roles::Participant& l, const ::matt::roles::Participant& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
matt::roles::operator<(const ::matt::roles::Participant& l, const ::matt::roles::Participant& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
matt::roles::operator<=(const ::matt::roles::Participant& l, const ::matt::roles::Participant& r)
{
    return l < r || l == r;
}

bool
matt::roles::operator>(const ::matt::roles::Participant& l, const ::matt::roles::Participant& r)
{
    return !(l < r) && !(l == r);
}

bool
matt::roles::operator>=(const ::matt::roles::Participant& l, const ::matt::roles::Participant& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
matt::roles::Mediator::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __matt__roles__Mediator_ids[2] =
{
    "::Ice::Object",
    "::matt::roles::Mediator"
};

bool
matt::roles::Mediator::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__matt__roles__Mediator_ids, __matt__roles__Mediator_ids + 2, _s);
}

::std::vector< ::std::string>
matt::roles::Mediator::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__matt__roles__Mediator_ids[0], &__matt__roles__Mediator_ids[2]);
}

const ::std::string&
matt::roles::Mediator::ice_id(const ::Ice::Current&) const
{
    return __matt__roles__Mediator_ids[1];
}

const ::std::string&
matt::roles::Mediator::ice_staticId()
{
    return __matt__roles__Mediator_ids[1];
}

::IceInternal::DispatchStatus
matt::roles::Mediator::___registerParticipant(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::matt::roles::ParticipantPrx p;
    ::matt::roles::__read(__is, p);
    registerParticipant(p, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __matt__roles__Mediator_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "registerParticipant"
};

::IceInternal::DispatchStatus
matt::roles::Mediator::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__matt__roles__Mediator_all, __matt__roles__Mediator_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __matt__roles__Mediator_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___registerParticipant(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
matt::roles::Mediator::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
matt::roles::Mediator::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
matt::roles::Mediator::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::roles::Mediator was not generated with stream support";
    throw ex;
}

void
matt::roles::Mediator::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type matt::roles::Mediator was not generated with stream support";
    throw ex;
}

void 
matt::roles::__patch__MediatorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::matt::roles::MediatorPtr* p = static_cast< ::matt::roles::MediatorPtr*>(__addr);
    assert(p);
    *p = ::matt::roles::MediatorPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::matt::roles::Mediator::ice_staticId();
        throw e;
    }
}

bool
matt::roles::operator==(const ::matt::roles::Mediator& l, const ::matt::roles::Mediator& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
matt::roles::operator!=(const ::matt::roles::Mediator& l, const ::matt::roles::Mediator& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
matt::roles::operator<(const ::matt::roles::Mediator& l, const ::matt::roles::Mediator& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
matt::roles::operator<=(const ::matt::roles::Mediator& l, const ::matt::roles::Mediator& r)
{
    return l < r || l == r;
}

bool
matt::roles::operator>(const ::matt::roles::Mediator& l, const ::matt::roles::Mediator& r)
{
    return !(l < r) && !(l == r);
}

bool
matt::roles::operator>=(const ::matt::roles::Mediator& l, const ::matt::roles::Mediator& r)
{
    return !(l < r);
}
