// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `matt.ice'

#ifndef __cpp_matt_h__
#define __cpp_matt_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace matt
{

namespace messaging
{

class EventListener;
bool operator==(const EventListener&, const EventListener&);
bool operator!=(const EventListener&, const EventListener&);
bool operator<(const EventListener&, const EventListener&);
bool operator<=(const EventListener&, const EventListener&);
bool operator>(const EventListener&, const EventListener&);
bool operator>=(const EventListener&, const EventListener&);

class Mailbox;
bool operator==(const Mailbox&, const Mailbox&);
bool operator!=(const Mailbox&, const Mailbox&);
bool operator<(const Mailbox&, const Mailbox&);
bool operator<=(const Mailbox&, const Mailbox&);
bool operator>(const Mailbox&, const Mailbox&);
bool operator>=(const Mailbox&, const Mailbox&);

}

namespace roles
{

class Participant;
bool operator==(const Participant&, const Participant&);
bool operator!=(const Participant&, const Participant&);
bool operator<(const Participant&, const Participant&);
bool operator<=(const Participant&, const Participant&);
bool operator>(const Participant&, const Participant&);
bool operator>=(const Participant&, const Participant&);

class Mediator;
bool operator==(const Mediator&, const Mediator&);
bool operator!=(const Mediator&, const Mediator&);
bool operator<(const Mediator&, const Mediator&);
bool operator<=(const Mediator&, const Mediator&);
bool operator>(const Mediator&, const Mediator&);
bool operator>=(const Mediator&, const Mediator&);

}

}

}

namespace matt
{

namespace messaging
{

class EventListener;
bool operator==(const EventListener&, const EventListener&);
bool operator!=(const EventListener&, const EventListener&);
bool operator<(const EventListener&, const EventListener&);
bool operator<=(const EventListener&, const EventListener&);
bool operator>(const EventListener&, const EventListener&);
bool operator>=(const EventListener&, const EventListener&);

class Mailbox;
bool operator==(const Mailbox&, const Mailbox&);
bool operator!=(const Mailbox&, const Mailbox&);
bool operator<(const Mailbox&, const Mailbox&);
bool operator<=(const Mailbox&, const Mailbox&);
bool operator>(const Mailbox&, const Mailbox&);
bool operator>=(const Mailbox&, const Mailbox&);

}

namespace roles
{

class Participant;
bool operator==(const Participant&, const Participant&);
bool operator!=(const Participant&, const Participant&);
bool operator<(const Participant&, const Participant&);
bool operator<=(const Participant&, const Participant&);
bool operator>(const Participant&, const Participant&);
bool operator>=(const Participant&, const Participant&);

class Mediator;
bool operator==(const Mediator&, const Mediator&);
bool operator!=(const Mediator&, const Mediator&);
bool operator<(const Mediator&, const Mediator&);
bool operator<=(const Mediator&, const Mediator&);
bool operator>(const Mediator&, const Mediator&);
bool operator>=(const Mediator&, const Mediator&);

}

}

namespace IceInternal
{

void incRef(::matt::messaging::EventListener*);
void decRef(::matt::messaging::EventListener*);

void incRef(::IceProxy::matt::messaging::EventListener*);
void decRef(::IceProxy::matt::messaging::EventListener*);

void incRef(::matt::messaging::Mailbox*);
void decRef(::matt::messaging::Mailbox*);

void incRef(::IceProxy::matt::messaging::Mailbox*);
void decRef(::IceProxy::matt::messaging::Mailbox*);

void incRef(::matt::roles::Participant*);
void decRef(::matt::roles::Participant*);

void incRef(::IceProxy::matt::roles::Participant*);
void decRef(::IceProxy::matt::roles::Participant*);

void incRef(::matt::roles::Mediator*);
void decRef(::matt::roles::Mediator*);

void incRef(::IceProxy::matt::roles::Mediator*);
void decRef(::IceProxy::matt::roles::Mediator*);

}

namespace matt
{

namespace messaging
{

typedef ::IceInternal::Handle< ::matt::messaging::EventListener> EventListenerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::matt::messaging::EventListener> EventListenerPrx;

void __write(::IceInternal::BasicStream*, const EventListenerPrx&);
void __read(::IceInternal::BasicStream*, EventListenerPrx&);
void __write(::IceInternal::BasicStream*, const EventListenerPtr&);
void __patch__EventListenerPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const EventListenerPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const EventListenerPtr&);
void __decRefUnsafe(const EventListenerPtr&);
void __clearHandleUnsafe(EventListenerPtr&);

typedef ::IceInternal::Handle< ::matt::messaging::Mailbox> MailboxPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::matt::messaging::Mailbox> MailboxPrx;

void __write(::IceInternal::BasicStream*, const MailboxPrx&);
void __read(::IceInternal::BasicStream*, MailboxPrx&);
void __write(::IceInternal::BasicStream*, const MailboxPtr&);
void __patch__MailboxPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const MailboxPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const MailboxPtr&);
void __decRefUnsafe(const MailboxPtr&);
void __clearHandleUnsafe(MailboxPtr&);

}

namespace roles
{

typedef ::IceInternal::Handle< ::matt::roles::Participant> ParticipantPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::matt::roles::Participant> ParticipantPrx;

void __write(::IceInternal::BasicStream*, const ParticipantPrx&);
void __read(::IceInternal::BasicStream*, ParticipantPrx&);
void __write(::IceInternal::BasicStream*, const ParticipantPtr&);
void __patch__ParticipantPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const ParticipantPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const ParticipantPtr&);
void __decRefUnsafe(const ParticipantPtr&);
void __clearHandleUnsafe(ParticipantPtr&);

typedef ::IceInternal::Handle< ::matt::roles::Mediator> MediatorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::matt::roles::Mediator> MediatorPrx;

void __write(::IceInternal::BasicStream*, const MediatorPrx&);
void __read(::IceInternal::BasicStream*, MediatorPrx&);
void __write(::IceInternal::BasicStream*, const MediatorPtr&);
void __patch__MediatorPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const MediatorPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const MediatorPtr&);
void __decRefUnsafe(const MediatorPtr&);
void __clearHandleUnsafe(MediatorPtr&);

}

}

namespace matt
{

class MattException : public ::Ice::UserException
{
public:

    MattException() {}
    explicit MattException(const ::std::string&);
    virtual ~MattException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string description;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static MattException __MattException_init;

class MattNotActiveException : public ::matt::MattException
{
public:

    MattNotActiveException() {}
    explicit MattNotActiveException(const ::std::string&);
    virtual ~MattNotActiveException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class MattNoMessageException : public ::matt::MattException
{
public:

    MattNoMessageException() {}
    explicit MattNoMessageException(const ::std::string&);
    virtual ~MattNoMessageException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class MattListenException : public ::matt::MattException
{
public:

    MattListenException() {}
    explicit MattListenException(const ::std::string&);
    virtual ~MattListenException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class MattAlreadyListeningException : public ::matt::MattListenException
{
public:

    MattAlreadyListeningException() {}
    explicit MattAlreadyListeningException(const ::std::string&);
    virtual ~MattAlreadyListeningException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class MattNotListeningException : public ::matt::MattListenException
{
public:

    MattNotListeningException() {}
    explicit MattNotListeningException(const ::std::string&);
    virtual ~MattNotListeningException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

namespace messaging
{

enum EventType
{
    Message,
    Closed
};

void __write(::IceInternal::BasicStream*, EventType);
void __read(::IceInternal::BasicStream*, EventType&);

}

namespace roles
{

}

}

namespace IceProxy
{

namespace matt
{

namespace messaging
{

class EventListener : virtual public ::IceProxy::Ice::Object
{
public:

    void onEvent(::matt::messaging::EventType event, const ::std::string& message)
    {
        onEvent(event, message, 0);
    }
    void onEvent(::matt::messaging::EventType event, const ::std::string& message, const ::Ice::Context& __ctx)
    {
        onEvent(event, message, &__ctx);
    }
    
private:

    void onEvent(::matt::messaging::EventType, const ::std::string&, const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class Mailbox : virtual public ::IceProxy::Ice::Object
{
public:

    bool empty()
    {
        return empty(0);
    }
    bool empty(const ::Ice::Context& __ctx)
    {
        return empty(&__ctx);
    }
    
private:

    bool empty(const ::Ice::Context*);
    
public:

    bool active()
    {
        return active(0);
    }
    bool active(const ::Ice::Context& __ctx)
    {
        return active(&__ctx);
    }
    
private:

    bool active(const ::Ice::Context*);
    
public:

    ::std::string read()
    {
        return read(0);
    }
    ::std::string read(const ::Ice::Context& __ctx)
    {
        return read(&__ctx);
    }
    
private:

    ::std::string read(const ::Ice::Context*);
    
public:

    void write(const ::std::string& message)
    {
        write(message, 0);
    }
    void write(const ::std::string& message, const ::Ice::Context& __ctx)
    {
        write(message, &__ctx);
    }
    
private:

    void write(const ::std::string&, const ::Ice::Context*);
    
public:

    void addListener(const ::matt::messaging::EventListenerPrx& listener)
    {
        addListener(listener, 0);
    }
    void addListener(const ::matt::messaging::EventListenerPrx& listener, const ::Ice::Context& __ctx)
    {
        addListener(listener, &__ctx);
    }
    
private:

    void addListener(const ::matt::messaging::EventListenerPrx&, const ::Ice::Context*);
    
public:

    void removeListener()
    {
        removeListener(0);
    }
    void removeListener(const ::Ice::Context& __ctx)
    {
        removeListener(&__ctx);
    }
    
private:

    void removeListener(const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

namespace roles
{

class Participant : virtual public ::IceProxy::Ice::Object
{
public:

    void setMailbox(const ::matt::messaging::MailboxPrx& mb)
    {
        setMailbox(mb, 0);
    }
    void setMailbox(const ::matt::messaging::MailboxPrx& mb, const ::Ice::Context& __ctx)
    {
        setMailbox(mb, &__ctx);
    }
    
private:

    void setMailbox(const ::matt::messaging::MailboxPrx&, const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class Mediator : virtual public ::IceProxy::Ice::Object
{
public:

    void registerParticipant(const ::matt::roles::ParticipantPrx& p)
    {
        registerParticipant(p, 0);
    }
    void registerParticipant(const ::matt::roles::ParticipantPrx& p, const ::Ice::Context& __ctx)
    {
        registerParticipant(p, &__ctx);
    }
    
private:

    void registerParticipant(const ::matt::roles::ParticipantPrx&, const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

}

namespace IceDelegate
{

namespace matt
{

namespace messaging
{

class EventListener : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void onEvent(::matt::messaging::EventType, const ::std::string&, const ::Ice::Context*) = 0;
};

class Mailbox : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual bool empty(const ::Ice::Context*) = 0;

    virtual bool active(const ::Ice::Context*) = 0;

    virtual ::std::string read(const ::Ice::Context*) = 0;

    virtual void write(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void addListener(const ::matt::messaging::EventListenerPrx&, const ::Ice::Context*) = 0;

    virtual void removeListener(const ::Ice::Context*) = 0;
};

}

namespace roles
{

class Participant : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void setMailbox(const ::matt::messaging::MailboxPrx&, const ::Ice::Context*) = 0;
};

class Mediator : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void registerParticipant(const ::matt::roles::ParticipantPrx&, const ::Ice::Context*) = 0;
};

}

}

}

namespace IceDelegateM
{

namespace matt
{

namespace messaging
{

class EventListener : virtual public ::IceDelegate::matt::messaging::EventListener,
                      virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void onEvent(::matt::messaging::EventType, const ::std::string&, const ::Ice::Context*);
};

class Mailbox : virtual public ::IceDelegate::matt::messaging::Mailbox,
                virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual bool empty(const ::Ice::Context*);

    virtual bool active(const ::Ice::Context*);

    virtual ::std::string read(const ::Ice::Context*);

    virtual void write(const ::std::string&, const ::Ice::Context*);

    virtual void addListener(const ::matt::messaging::EventListenerPrx&, const ::Ice::Context*);

    virtual void removeListener(const ::Ice::Context*);
};

}

namespace roles
{

class Participant : virtual public ::IceDelegate::matt::roles::Participant,
                    virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void setMailbox(const ::matt::messaging::MailboxPrx&, const ::Ice::Context*);
};

class Mediator : virtual public ::IceDelegate::matt::roles::Mediator,
                 virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void registerParticipant(const ::matt::roles::ParticipantPrx&, const ::Ice::Context*);
};

}

}

}

namespace IceDelegateD
{

namespace matt
{

namespace messaging
{

class EventListener : virtual public ::IceDelegate::matt::messaging::EventListener,
                      virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void onEvent(::matt::messaging::EventType, const ::std::string&, const ::Ice::Context*);
};

class Mailbox : virtual public ::IceDelegate::matt::messaging::Mailbox,
                virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual bool empty(const ::Ice::Context*);

    virtual bool active(const ::Ice::Context*);

    virtual ::std::string read(const ::Ice::Context*);

    virtual void write(const ::std::string&, const ::Ice::Context*);

    virtual void addListener(const ::matt::messaging::EventListenerPrx&, const ::Ice::Context*);

    virtual void removeListener(const ::Ice::Context*);
};

}

namespace roles
{

class Participant : virtual public ::IceDelegate::matt::roles::Participant,
                    virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void setMailbox(const ::matt::messaging::MailboxPrx&, const ::Ice::Context*);
};

class Mediator : virtual public ::IceDelegate::matt::roles::Mediator,
                 virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void registerParticipant(const ::matt::roles::ParticipantPrx&, const ::Ice::Context*);
};

}

}

}

namespace matt
{

namespace messaging
{

class EventListener : virtual public ::Ice::Object
{
public:

    typedef EventListenerPrx ProxyType;
    typedef EventListenerPtr PointerType;
    
    EventListener() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void onEvent(::matt::messaging::EventType, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___onEvent(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__EventListenerPtr(void*, ::Ice::ObjectPtr&);

class Mailbox : virtual public ::Ice::Object
{
public:

    typedef MailboxPrx ProxyType;
    typedef MailboxPtr PointerType;
    
    Mailbox() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual bool empty(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___empty(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool active(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___active(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string read(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___read(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void write(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___write(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addListener(const ::matt::messaging::EventListenerPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addListener(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeListener(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeListener(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__MailboxPtr(void*, ::Ice::ObjectPtr&);

}

namespace roles
{

class Participant : virtual public ::Ice::Object
{
public:

    typedef ParticipantPrx ProxyType;
    typedef ParticipantPtr PointerType;
    
    Participant() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void setMailbox(const ::matt::messaging::MailboxPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___setMailbox(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__ParticipantPtr(void*, ::Ice::ObjectPtr&);

class Mediator : virtual public ::Ice::Object
{
public:

    typedef MediatorPrx ProxyType;
    typedef MediatorPtr PointerType;
    
    Mediator() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void registerParticipant(const ::matt::roles::ParticipantPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___registerParticipant(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__MediatorPtr(void*, ::Ice::ObjectPtr&);

}

}

#endif
